﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace DBAPI
{
    public partial class Form1 : Form
    {
        int LastID = 0;
        clsDB ObjDB = new clsDB();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //By default, the sample will run on Amadeus5 PC, 
            //so we fill the local PC name 
            txtServerName.Text  = Environment.MachineName;
            
            //in our sample we considere we work in SQL server
            clsGlobal.dbTypeID = clsGlobal.DBType.SqlServer;

        }

        private void btnInsert_Click(object sender, EventArgs e)
        {
            clsGlobal.OleDB_ConnectionString = txtConnectionString.Text;
            lblStatus.Text =  "";
            lblStatus.Visible = true;


            try
            {
                ObjDB.InsertQueueMSGAPI(txtServerName.Text, txtCommand.Text, txtParams.Text);
                getLastID();
                lblStatus.Text = "Inserted successfully ID " + LastID.ToString () + " ... ";
                timerStatus.Enabled = true;  
            }
            catch
            {
                lblStatus.Text = "Insert failure"; 
            }

        }

        private void getLastID() 
        {
            LastID = 0;
            DataTable dtb = ObjDB.getDataTable("Select top 1 ID from [QueueMsgAPI] order by ID DESC");
            if (dtb.Rows.Count > 0)
                LastID = clsGlobal.oTi(dtb.Rows[0]["ID"]);
        }

        private void CheckStatus()
        {
            DataTable dtb = ObjDB.getDataTable("Select Status, Result from [QueueMsgAPI] Where ID = " + LastID );
            if (dtb.Rows.Count > 0)
            {
                switch (clsGlobal.oTi(dtb.Rows[0]["Status"]))
                {
                    case 0:
                        lblStatus.Text = "Waiting for Server to execute ID " + LastID.ToString() + " ... ";
                        break;
                    case 1:
                        lblStatus.Text = "Server start to execute ID " + LastID.ToString() + " ... ";
                        break;
                    case 2:
                        string res = (clsGlobal.oTi(dtb.Rows[0]["Result"]) == 1) ? "OK" : "Error";
                        lblStatus.Text  = "Server finish to to execute ID " + LastID.ToString () + ".  Result " + res; 
                        timerStatus.Enabled = false ;  
                        break;
                }
            }       
        
        }

        private void timerStatus_Tick(object sender, EventArgs e)
        {
            CheckStatus();
        }

        private void btnTest_Click(object sender, EventArgs e)
        {
            clsGlobal.OleDB_ConnectionString = txtConnectionString.Text;
            DataTable dtb = ObjDB.getDataTable("Select Count(ID) as Cnt from [QueueMsgAPI]");
            if (dtb.Rows.Count > 0)
                MessageBox.Show("Connection OK !" + Environment.NewLine + clsGlobal.oTi(dtb.Rows[0]["Cnt"]).ToString() + " records in the table");
            else
                MessageBox.Show("Connection not OK !");
        }

//Sample XML API Syntax

        private void btnSampleOpenRelay_Click(object sender, EventArgs e)
        {
            txtCommand.Text = "ActivateRelay";
            txtParams.Text = "<query><OutputID>1</OutputID><Delay>3</Delay></query>";
            btnInsert_Click(sender,e) ;
        }

        private void btnSampleOpenScreen_Click(object sender, EventArgs e)
        {
            txtCommand.Text = "OpenScreen";
            txtParams.Text = "<query><Param1>ID_Cardholders</Param1></query>";
            //Optional Paramters 
            //<Param3>0</Param3><Param4>0</Param4><onRecordID>0</onRecordID><onTabNumber>0</onTabNumber>
            btnInsert_Click(sender, e);
        }

        private void btnSampleWriteLog_Click(object sender, EventArgs e)
        {
            txtCommand.Text = "MenuPrint";
            txtParams.Text = "<query><st>Hi, How are you ? </st><Soc>1</Soc><mStyle>0</mStyle><JustinLog>0</JustinLog><inViewPhotoAlso>0</inViewPhotoAlso></query>";
            //Optional Paramters 
            //<Soc>1</Soc><mStyle>0</mStyle><JustinLog>0</JustinLog><inViewPhotoAlso>0</inViewPhotoAlso>
            btnInsert_Click(sender, e);
        }

        private void btnSampleImportCardholder_Click(object sender, EventArgs e)
        {
            txtCommand.Text = "ImportOneCardHolderXML";
            txtParams.Text = @"<query>
<Number>000128</Number>
<Last_Name>Smith</Last_Name>
<First_Name>John</First_Name>
<Type>1</Type>
<Badge>9014585D</Badge>
<Technology>3</Technology>
<Access_Group>Anytime Anywhere</Access_Group>
</query>";
            btnInsert_Click(sender, e);
        }

   
    


    }
}
